// ==UserScript==
// @name         Unity2Playcanvas
// @namespace    http://tampermonkey.net/
// @version      1.0.9
// @description  try to take over the world!
// @author       CC
// @match        https://playcanvas.com/editor/scene/*
// @icon         https://www.google.com/s2/favicons?sz=64&domain=playcanvas.com
// @grant        none
// ==/UserScript==

(function () {
    'use strict';
    // ui api
    function createMainPanel() {
        console.log('createMainPanel');
        const ui = new pcui.Panel({
            collapseHorizontally: false,
            collapsible: true,
            collapsed: true,
            removable: true,
            scrollable: true,
            resizable: 'top',
            resizeMax: 400,
            headerText: 'Unity2Playcanvas_v1.0.9'
        });
        ui.style.position = 'absolute';
        ui.style.height = '400px';
        ui.style.width = '300px';
        ui.style.bottom = '5px';
        ui.style.right = '5px';
        /* icon list
        for(let i = 0; i < 5; i++){
            for(let j = 0; j < 10; j++){
                for(let k = 0; k < 10; k++){
                    let icon = 'E' + i + j + k;
                    let btn = new pcui.Button({ text: icon, icon: icon });
                    btn.on('click', () => {
                        console.log('icon: ' + icon);
                    });
                    ui.append(btn);
                }
            }
        }//*/
        editor.call('layout.viewport').append(ui);
        return ui;
    }

    function createButton(text, style, action) {
        console.log('createButton: ' + text);
        const ui = new pcui.Button({ text: text }); // icon: E400
        if (style) {
            ui.style.position = style.position;
            ui.style.bottom = style.bottom;
            ui.style.right = style.right;
        }
        mainPanelUI.append(ui);

        ui.on('click', action);
        return ui;
    }

    function radioButton() {
        const ui = new pcui.RadioButton({});
        mainPanelUI.append(ui);
        ui.on('change', async (value) => {
            console.log('on radioButton change: ' + value);
            debugSelection = value;
        });
    }

    function testButton() {
        let text = 'test';
        console.log('createButton: ' + text);
        // let style = {position: 'absolute', bottom: '5px', right: '5px'};
        const ui = new pcui.Button({ text: text });
        // ui.style.backgroundColor = '#4E3534';

        mainPanelUI.append(ui);

        ui.on('click', async () => {
            console.log('on Button click: ' + text);
            /* log editor api
            //console.log('editor:');
            //console.log(editor);
            for (let asset of editor.assets.list()) {
                if (asset.get('type') === 'render') {
                    console.log('name: ' + asset.get('name') + ', containerAsset: ' + asset.get('data.containerAsset') + ', renderIndex: ' + asset.get('data.renderIndex'));
                    // containerAsset
                    // renderIndex
                }
            }
            //let projectSettings = editor.call('settings:project');
            //console.log(projectSettings);
            //console.log(projectSettings.get('layerOrder'));
            //projectSettings.move("layerOrder", 0, 1);
            //console.log(projectSettings.get('layerOrder'));
            //*/
        });
    }

    function progressButton() {
        let text = 'Run Progress';
        console.log('createButton: ' + text);
        // let style = {position: 'absolute', bottom: '5px', right: '5px'};
        const ui = new pcui.Button({ text: text }); // icon: E400
        // ui.style.backgroundColor = '#4E3534';

        mainPanelUI.append(ui);

        ui.on('click', async () => {
            console.log('on Button click: ' + text);
            mainPanelUI.remove(ui);
            await runProgress();
            createDivider();
            createClearCreatedButton();
            //radioButton();
        });
    }

    function createClearCreatedButton() {
        let text = 'Clear Created';
        // let style = {position: 'absolute', bottom: '35px', right: '5px'};
        let ui = createButton(text, null, async () => {
            console.log('on Button click: ' + text);
            mainPanelUI.remove(ui);
            progressUI = createProgress();
            await clearCreated();
            mainPanelUI.clear();
            initMainPanel();
        });
    }

    function createClearWorkFolderButton() {
        let text = 'Clear Work Folder';
        // let style = {position: 'absolute', bottom: '35px', right: '5px'};
        let ui = createButton(text, null, async () => {
            console.log('on Button click: ' + text);
            mainPanelUI.remove(ui);
            progressUI = createProgress();
            await clearCreated();
            mainPanelUI.clear();
            initMainPanel();
        });
    }

    function clearSceneButton() {
        let text = 'Clear Scene';
        // let style = {position: 'absolute', bottom: '35px', right: '5px'};
        let ui = createButton(text, null, async () => {
            console.log('on Button click: ' + text);
            mainPanelUI.remove(ui);
            progressUI = createProgress();
            await clearCreated();
            mainPanelUI.clear();
            initMainPanel();
        });
    }

    function createInfoBox() {
        let text = 'test info box';
        console.log('createInfoBox: ' + text);
        const ui = new pcui.InfoBox({ text: text, title: 'Info Box', icon: 'E400' });
        ui.style.position = 'absolute';
        ui.style.bottom = '100px';
        ui.style.right = '50px';

        editor.call('layout.viewport').append(ui);
        return ui;
    }

    function createProgress(value = 0) {
        console.log('createProgress: ' + value);
        let ui = new pcui.Progress({ value: value });
        ui.style.height = '10px';
        //ui.style.position = 'absolute';
        //ui.style.top = '5px';
        /*
        setInterval(() => {
            ui.value++;
            if (ui.value === 100) {
                ui.value = 0;
            }
        }, 20); //*/
        mainPanelUI.append(ui);
        return ui;
    }

    function setProgressUI(on = false, value = 0) {
        if (on) {
            if (progressUI === null) {
                progressUI = createProgress(value);
            } else {
                progressUI.value = value;
            }
        } else if (progressUI !== null) {
            console.log('setProgressUI destroy');
            progressUI.destroy();
            progressUI = null;
        }
    }

    function createTopLabelGroup() {
        let labelG2 = new pcui.LabelGroup({
            text: 'view',
            field: new pcui.Label({ text: '' })
        })
        let labelG1 = new pcui.LabelGroup({
            text: 'status',
            field: labelG2
        })
        let labelG0 = new pcui.LabelGroup({
            text: 'name',
            field: labelG1
        })
        mainPanelUI.append(labelG0);
        return labelG0;
    }

    function createEntityLog(entity, log) {
        if (entity) {
            if (!log || log === '') {
                log = 'ok';
            }
            let btn = new pcui.Button({ text: 'view', icon: 'E308' });
            btn.on('click', () => {
                if (entity) {
                    editor.selection.set([entity]);
                }
            });
            let labelG1 = new pcui.LabelGroup({
                text: log,
                field: btn,
                nativeTooltip: true
            })
            let labelG0 = new pcui.LabelGroup({
                text: entity.get('name'),
                field: labelG1,
                nativeTooltip: true
            })
            if (log == 'has unsupport') { // yellow background
                labelG1.style.backgroundColor = '#413C26';
                labelG0.style.backgroundColor = '#413C26';
            } else if (log !== 'ok') { // red background
                labelG1.style.backgroundColor = '#4E3534';
                labelG0.style.backgroundColor = '#4E3534';
            }
            labelG0.style.width = '280px';
            mainPanelUI.append(labelG0);
        }
    }

    function createLabelLog(text, error = false) {
        let ui = new pcui.Label({ text: text, nativeTooltip: true });
        if (error) {
            ui.style.backgroundColor = '#4E3534';
        }
        mainPanelUI.append(ui);
        return ui;
    }

    function createDivider(height = '3px') {
        let ui = new pcui.Divider();
        if (height) {
            ui.style.height = height;
        }
        mainPanelUI.append(ui);
        return ui;
    }

    function initMainPanel() {
        if (!mainPanelUI) {
            mainPanelUI = createMainPanel();
        }
        //createTopLabelGroup();
        //createDivider('5px');
        progressButton();
        //testButton();
    }
    // base api
    function sleep(ms) {
        return new Promise(resolve => setTimeout(resolve, ms));
    }

    function api(url) {
        return fetch(url)
            .then((response) => {
                if (!response.ok) {
                    console.error('fetch error: ' + response.statusText);
                }
                return response.json();
            });
    }
    // playcanvas editor api
    // components
    function componentsLight(component, entity) {
        //console.log('components.light!');
        if (!entity) {
            return;
        }
        if (entity.has('components.light')) {
            entity.removeComponent('light');
        }
        if (component) {
            entity.addComponent('light', component);
        }
    }

    function componentsCamera(component, entity) {
        //console.log('components.camera!');
        if (!entity) {
            return;
        }
        if (entity.has('components.camera')) {
            entity.removeComponent('camera');
        }
        if (component) {
            entity.addComponent('camera', component);
        }
    }

    async function componentsRender(component, entity) {
        //console.log('components.render!');
        let log = '';
        if (!entity) {
            return log;
        }
        if (entity.has('components.render')) {
            entity.removeComponent('render');
        }
        if (component) {
            let tmpData = Object.assign(true, {}, component);
            if (tmpData.type === 'asset') {
                if (assetFileDic[tmpData.asset]) {
                    tmpData.asset = assetFileDic[tmpData.asset];
                } else {
                    tmpData.asset = null;
                    log += ', missing render mesh';
                }
            }
            let mAssets = [];
            let error = false;
            for (let aid of tmpData.materialAssets) {
                if (aid) {
                    if (assetFileDic[aid]) {
                        mAssets.push(assetFileDic[aid]);
                    } else {
                        error = true;
                    }
                }
            }
            if (error) {
                log += ', missing material assets';
            }
            tmpData.materialAssets = mAssets;
            entity.addComponent('render', tmpData);
            if (component.rootBone) {
                entity.set('components.render.rootBone', null);
            }
        }
        return log;
    }

    function componentsAnim(component, entity) {
        //console.log('components.anim! ' + component.stateGraphAsset);
        let log = '';
        if (!entity) {
            return log;
        }
        if (entity.has('components.anim')) {
            entity.removeComponent('anim');
        }
        if (component) {
            let tmpData = Object.assign(true, {}, component);
            if (assetFileDic[tmpData.stateGraphAsset]) {
                let error = false;
                tmpData.stateGraphAsset = assetFileDic[tmpData.stateGraphAsset];
                for (let [layer, asset] of Object.entries(tmpData.animationAssets)) {
                    if (assetFileDic[asset.asset]) {
                        asset.asset = assetFileDic[asset.asset];
                    } else {
                        asset.asset = null;
                        error = true;
                    }
                }
                if (error) {
                    log += ', missing animation';
                }
            } else {
                log += ', missing state graph';
            }
            entity.addComponent('anim', tmpData);
        }
        return log;
    }

    function componentsAudioListener(component, entity) {
        //console.log('components.audiolistener!');
        if (!entity) {
            return;
        }
        if (entity.has('components.audiolistener')) {
            entity.removeComponent('audiolistener');
        }
        if (component) {
            entity.addComponent('audiolistener', component);
        }
    }

    function componentsSound(component, entity) {
        //console.log('components.sound!');
        let log = '';
        if (!entity) {
            return log;
        }
        if (entity.has('components.sound')) {
            entity.removeComponent('sound');
        }
        if (component) {
            entity.addComponent('sound', component);
            if (component.slots) {
                for (let [id, slot] of Object.entries(component.slots)) {
                    if (slot && slot.asset) {
                        if (assetFileDic[slot.asset]) {
                            entity.set('components.sound.slots.1.asset', assetFileDic[slot.asset]);
                        } else {
                            entity.set('components.sound.slots.1.asset', null);
                            log += ', missing sound asset';
                        }
                    }
                }
            }
        }
        return log;
    }

    function componentsSprite(component, entity) {
        //console.log('components.sprite!');
        let log = '';
        if (!entity) {
            return log;
        }
        if (entity.has('components.sprite')) {
            entity.removeComponent('sprite');
        }
        if (component) {
            let tmpData = Object.assign(true, {}, component);
            if (component.spriteAsset) {
                if (assetFileDic[tmpData.spriteAsset]) {
                    tmpData.spriteAsset = assetFileDic[tmpData.spriteAsset];
                    for (let [id, clip] of Object.entries(tmpData.clips)) {
                        if (clip && clip.spriteAsset) {
                            if (assetFileDic[clip.spriteAsset]) {
                                clip.spriteAsset = assetFileDic[clip.spriteAsset];
                            } else {
                                clip.spriteAsset = null;
                                log += ', missing clips';
                            }
                        }
                    }
                } else {
                    tmpData.spriteAsset = null;
                    log += ', missing sprite asset';
                }
            }
            entity.addComponent('sprite', tmpData);
        }
        return log;
    }

    function componentsScreen(component, entity) {
        //console.log('components.screen!');
        if (!entity) {
            return;
        }
        if (entity.has('components.screen')) {
            entity.removeComponent('screen');
        }
        if (component) {
            entity.addComponent('screen', component);
        }
    }

    function componentsElement(component, entity) {
        //console.log('components.element!');
        let log = '';
        if (!entity) {
            return log;
        }
        if (entity.has('components.element')) {
            entity.removeComponent('element');
        }
        if (component) {
            let tmpData = Object.assign(true, {}, component);
            tmpData.textureAsset = null;
            tmpData.spriteAsset = null;
            tmpData.materialAsset = null;
            tmpData.fontAsset = null;
            entity.addComponent('element', tmpData);
            if (component.textureAsset) {
                if (assetFileDic[component.textureAsset]) {
                    entity.set('components.element.textureAsset', assetFileDic[component.textureAsset]);
                } else {
                    entity.set('components.element.textureAsset', null);
                    log += ', missing element textureAsset';
                }
            }
            if (component.spriteAsset) {
                if (assetFileDic[component.spriteAsset]) {
                    entity.set('components.element.spriteAsset', assetFileDic[component.spriteAsset]);
                } else {
                    entity.set('components.element.spriteAsset', null);
                    log += ', missing element spriteAsset';
                }
            }
            if (component.materialAsset) {
                if (assetFileDic[component.materialAsset]) {
                    entity.set('components.element.materialAsset', assetFileDic[component.materialAsset]);
                } else {
                    entity.set('components.element.materialAsset', null);
                    log += ', missing element materialAsset';
                }
            }
            if (component.fontAsset) {
                if (assetFileDic[component.fontAsset]) {
                    entity.set('components.element.fontAsset', assetFileDic[component.fontAsset]);
                } else {
                    entity.set('components.element.fontAsset', null);
                    log += ', missing element fontAsset';
                }
            }
        }
        return log;
    }

    function componentsButton(component, entity) {
        //console.log('components.button!');
        let log = '';
        if (!entity) {
            return log;
        }
        if (entity.has('components.button')) {
            entity.removeComponent('button');
        }
        if (component) {
            entity.addComponent('button', component);
            if (component.imageEntity) {
                if (entityDic[component.imageEntity]) {
                    entity.set('component.imageEntity', entityDic[component.imageEntity]);
                } else {
                    entity.set('components.button.imageEntity', null);
                    log += ', missing imageEntity';
                }
            }
        }
        return log;
    }

    function componentsCollision(component, entity) {
        //console.log('components.collision!');
        let log = '';
        if (!entity) {
            return log;
        }
        if (entity.has('components.collision')) {
            entity.removeComponent('collision');
        }
        if (component) {
            let tmpData = Object.assign(true, {}, component);
            //tmpData.asset = null;
            if (tmpData.renderAsset) {
                if (assetFileDic[tmpData.renderAsset]) {
                    tmpData.renderAsset = assetFileDic[tmpData.renderAsset];
                } else {
                    tmpData.renderAsset = null;
                    log += ', missing render mesh';
                }
            }
            entity.addComponent('collision', tmpData);
        }
        return log;
    }

    function componentsRigidbody(component, entity) {
        //console.log('components.rigidbody!');
        let log = '';
        if (!entity) {
            return log;
        }
        if (entity.has('components.rigidbody')) {
            entity.removeComponent('rigidbody');
        }
        if (component) {
            entity.addComponent('rigidbody', component);
        }
        return log;
    }

    function componentsParticlesystem(component, entity) {
        //console.log('components.particlesystem!');
        let log = '';
        if (!entity) {
            return log;
        }
        if (entity.has('components.particlesystem')) {
            entity.removeComponent('particlesystem');
        }
        if (component) {
            let tmpData = Object.assign(true, {}, component);
            if (tmpData.colorMapAsset) {
                if (assetFileDic[tmpData.colorMapAsset]) {
                    tmpData.colorMapAsset = assetFileDic[tmpData.colorMapAsset];
                } else {
                    tmpData.colorMapAsset = null;
                    log += ', missing colorMapAsset';
                }
            }
            if (tmpData.normalMapAsset) {
                if (assetFileDic[tmpData.normalMapAsset]) {
                    tmpData.normalMapAsset = assetFileDic[tmpData.normalMapAsset];
                } else {
                    tmpData.normalMapAsset = null;
                    log += ', missing normalMapAsset';
                }
            }
            if (tmpData.mesh) {
                if (assetFileDic[tmpData.mesh]) {
                    tmpData.mesh = assetFileDic[tmpData.mesh];
                } else {
                    tmpData.mesh = null;
                    log += ', missing mesh';
                }
            }
            if (tmpData.renderAsset) {
                if (assetFileDic[tmpData.renderAsset]) {
                    tmpData.renderAsset = assetFileDic[tmpData.renderAsset];
                } else {
                    tmpData.renderAsset = null;
                    log += ', missing render';
                }
            }
            entity.addComponent('particlesystem', tmpData);
        }
        return log;
    }

    function componentsLayoutgroup(component, entity) {
        //console.log('components.layoutgroup!');
        if (!entity) {
            return;
        }
        if (entity.has('components.layoutgroup')) {
            entity.removeComponent('layoutgroup');
        }
        if (component && entity) {
            entity.addComponent('layoutgroup', component);
        }
    }

    function componentsLayoutchild(component, entity) {
        //console.log('components.layoutchild!');
        if (!entity) {
            return;
        }
        if (entity.has('components.layoutchild')) {
            entity.removeComponent('layoutchild');
        }
        if (component && entity) {
            entity.addComponent('layoutchild', component);
        }
    }

    function componentsScrollview(component, entity) {
        //console.log('components.scrollview!');
        let log = '';
        if (!entity) {
            return log;
        }
        if (entity.has('components.scrollview')) {
            entity.removeComponent('scrollview');
        }
        if (component && entity) {
            let tmpData = Object.assign(true, {}, component);
            if (tmpData.viewportEntity) {
                if (entityDic[tmpData.viewportEntity]) {
                    tmpData.viewportEntity = entityDic[tmpData.viewportEntity];
                } else {
                    tmpData.viewportEntity = null;
                    log += ', missing viewportEntity';
                }
            }
            if (tmpData.contentEntity) {
                if (entityDic[tmpData.contentEntity]) {
                    tmpData.contentEntity = entityDic[tmpData.contentEntity];
                } else {
                    tmpData.contentEntity = null;
                    log += ', missing contentEntity';
                }
            }
            if (tmpData.horizontalScrollbarEntity) {
                if (entityDic[tmpData.horizontalScrollbarEntity]) {
                    tmpData.horizontalScrollbarEntity = entityDic[tmpData.horizontalScrollbarEntity];
                } else {
                    tmpData.horizontalScrollbarEntity = null;
                    log += ', missing horizontalScrollbarEntity';
                }
            }
            if (tmpData.verticalScrollbarEntity) {
                if (entityDic[tmpData.verticalScrollbarEntity]) {
                    tmpData.verticalScrollbarEntity = entityDic[tmpData.verticalScrollbarEntity];
                } else {
                    tmpData.verticalScrollbarEntity = null;
                    log += ', missing verticalScrollbarEntity';
                }
            }
            entity.addComponent('scrollview', tmpData);
        }
        return log;
    }

    function componentsScrollbar(component, entity) {
        //console.log('components.scrollbar!');
        let log = '';
        if (!entity) {
            return log;
        }
        if (entity.has('components.scrollbar')) {
            entity.removeComponent('scrollbar');
        }
        if (component && entity) {
            let tmpData = Object.assign(true, {}, component);
            if (tmpData.handleEntity) {
                if (entityDic[tmpData.handleEntity]) {
                    tmpData.handleEntity = entityDic[tmpData.handleEntity];
                } else {
                    tmpData.handleEntity = null;
                    log += ', missing handleEntity';
                }
            }
            entity.addComponent('scrollbar', tmpData);
        }
        return log;
    }

    // assets file
    async function instantiateTemplates(id, par) {
        let asset = editor.assets.get(id);
        //console.log(asset);
        if (!asset) {
            return [null];
        }
        if (!par) {
            par = entityDic['playcanvas_root'];
        } // editor.entities.root.get('children').length
        let result;
        for (let i = 0; i < 3; i++) {
            if (i != 0) {
                await sleep(i * 10);
                console.log('instantiateTemplates retry: ' + i);
            }
            await editor.assets.instantiateTemplates([asset], par, { index: par.get('children').length }).then((res) => {
                result = res;
            }).catch(response => {
                console.log('instantiateTemplates fail(' + i + '): ' + asset.get('name') + ', catch: ' + response);
            });
            if (result) {
                return result;
            }
        }
        console.warn('instantiateTemplates fail: ' + asset.get('name'));
        return [null];
    }

    async function createTemplates(name, entity, folder) {
        //console.log('createTemplates: ' + name);
        let tem;
        await editor.assets.createTemplate({ name: name, entity: entity, folder: folder }).then((res) => {
            tem = res;
        }).catch(response => {
            console.warn('createTemplate fail: ' + name + ', catch: ' + response);
        });
        if (!tem) { // createTemplate should return asset but ...
            tem = editor.assets.findOne(asset => asset.get('name') === name && asset.get('type') === 'template'
                && asset.get('path')[1] == templateFolderPathID);
        }
        //console.log('createTemplates: ' + tem.get('name') + ', id: ' + tem.get('id'));
        return tem;
    }

    async function createMaterial(data, folder) {
        //console.log('createMaterial: ' + data.name);
        let log = '';
        if (assetFileDic[data.id]) {
            let mat = editor.assets.findOne(asset => asset.get('id') === data.id);
            if (!mat) {
                mat = editor.assets.findOne(asset => asset.get('name') === data.name && asset.get('type') === 'material'
                    && asset.get('path')[1] == materialFolderPathID);
            }
            if (mat) {
                return [mat, log];
            }
        }
        let opt = {
            name: data.name,
            folder: folder,
            data: data.data, //editor.call('schema:material:getDefaultData'),
            preload: data.preload,
            onProgress: (progress) => {
                //console.log('createMaterial: ' + data.name + ', progress: ' + progress);
            },
        };
        //*
        if (opt.data.diffuseMap) {
            //console.log('data.diffuseMap: ' + opt.data.diffuseMap);
            if (assetFileDic[opt.data.diffuseMap]) {
                opt.data.diffuseMap = assetFileDic[opt.data.diffuseMap];
            } else {
                opt.data.diffuseMap = null;
                log += ', missing diffuseMap';
            }
        }
        if (opt.data.normalMap) {
            if (assetFileDic[opt.data.normalMap]) {
                opt.data.normalMap = assetFileDic[opt.data.normalMap];
            } else {
                opt.data.normalMap = null;
                log += ', missing normalMap';
            }
        }
        if (opt.data.emissiveMap) {
            if (assetFileDic[opt.data.emissiveMap]) {
                opt.data.emissiveMap = assetFileDic[opt.data.emissiveMap];
            } else {
                opt.data.emissiveMap = null;
                log += ', missing emissiveMap';
            }
        }
        if (opt.data.metalnessMap) {
            if (assetFileDic[opt.data.metalnessMap]) {
                opt.data.metalnessMap = assetFileDic[opt.data.metalnessMap];
            } else {
                opt.data.metalnessMap = null;
                log += ', missing metalnessMap';
            }
        }
        if (opt.data.heightMap) {
            if (assetFileDic[opt.data.heightMap]) {
                opt.data.heightMap = assetFileDic[opt.data.heightMap];
            } else {
                opt.data.heightMap = null;
                log += ', missing heightMap';
            }
        }
        if (opt.data.aoMap) {
            if (assetFileDic[opt.data.aoMap]) {
                opt.data.aoMap = assetFileDic[opt.data.aoMap];
            } else {
                opt.data.aoMap = null;
                log += ', missing aoMap';
            }
        }
        if (opt.data.opacityMap) {
            if (assetFileDic[opt.data.opacityMap]) {
                opt.data.opacityMap = assetFileDic[opt.data.opacityMap];
            } else {
                opt.data.opacityMap = null;
                log += ', missing opacityMap';
            }
        }//*/
        let mat;
        for (let i = 0; i < 3; i++) {
            if (i != 0) {
                await sleep(i * 10);
                console.log('createMaterial retry: ' + i);
            }
            await editor.assets.createMaterial(opt).then((res) => {
                mat = res;
            }).catch(response => {
                console.log('createMaterial fail: ' + data.name + ', catch: ' + response);
            });
            if (mat) {
                break;
            }
        }
        if (!mat) {
            console.warn('createMaterial fail: ' + data.name);
            return [mat, 'createMaterial fail'];
        }
        // set value after createMaterial
        if (opt.data.diffuseMap) {
            mat.set('data.diffuseTint', true);
        }
        if (opt.data.emissiveMap) {
            mat.set('data.emissiveTint', true);
        }
        if (opt.data.aoMap) {
            mat.set('data.ambientTint', true);
        }
        mat.set('data.useSkybox', opt.data.useSkybox);
        assetFileDic[data.id] = mat.get('id');

        //console.log('createMaterial data.id: ' + data.id + ', mat.id' + mat.get('id'));
        if (log != '') {
            console.log('createMaterial log: ' + log);
        }
        return [mat, log];
    }

    async function createAnimStateGraph(animData, folder) {
        //console.log('createAnimStateGraph: ' + animData.name);
        let opt = {
            name: animData.name,
            folder: folder,
            data: animData.data,
            preload: animData.preload,
            onProgress: (progress) => {
                //console.log('createAnimStateGraph: ' + data.name + ', progress: ' + progress);
            },
        };
        let tem = await editor.assets.createAnimStateGraph(opt);
        assetFileDic[animData.id] = tem.get('id');
        return tem;
    }

    async function createTextureAtlas(atlasData, folder) {
        //console.log('createTextureAtlas: ' + atlasData.name);
        let log = '';
        let texture = editor.assets.findOne(asset => asset.get('id') === assetFileDic[atlasData.id.replace('9999', '')]); // unity tool add 9999 to prevent duplicate id
        let atlas;
        if (texture) {
            editor.call("assets:textureToAtlas", texture);
            for (let i = 0; i < 10; i++) {
                await sleep(500);
                atlas = editor.assets.findOne(asset => asset.get('name') === atlasData.name && asset.get('type') === 'textureatlas'
                    && asset.get('path')[0] == sceneFolderPathID);
                if (atlas) {
                    //console.log('createTextureAtlas await:' + i);
                    break;
                }
            }
        }
        if (atlas) {
            atlas.set('data', atlasData.data);
            assetFileDic[atlasData.id] = atlas.get('id');
            assetCan.push(atlas.get('id'));
            //atlas.set('path', [sceneFolderPathID[0], folder.get('id')]);
            //console.log('createTextureAtlas atlasData id:' + atlasData.id + ', atlas id' + atlas.get('id'));
            //console.log(atlas);
        } else {
            console.log('createTextureAtlas missing atlas');
            log += ', missing atlas';
        }
        return [atlas, log];
    }

    async function createSprite(spriteData, folder) {
        //console.log('createSprite: ' + spriteData.name + ', id: ' + spriteData.data.textureAtlasAsset);
        let log = '';
        let opt = {
            name: spriteData.name,
            folder: folder,
            data: spriteData.data,
            preload: spriteData.preload,
            onProgress: (progress) => {
                //console.log('createSprite: ' + spriteData.name + ', progress: ' + progress);
            },
        };
        let tem = await editor.assets.createSprite(opt);
        if (assetFileDic[spriteData.data.textureAtlasAsset]) {
            //console.log('createSprite asset:' + assetFileDic[spriteData.data.textureAtlasAsset]);
            spriteData.data.textureAtlasAsset = assetFileDic[spriteData.data.textureAtlasAsset];
            tem.set('data', spriteData.data);
        } else {
            log += ', missing atlas';
        }
        assetFileDic[spriteData.id] = tem.get('id');
        return tem;
    }

    async function createCubemap(cubemapData, folder) {
        //console.log('createCubemap: ' + cubemapData.name);
        let log = '';
        let opt = {
            name: cubemapData.name,
            folder: folder,
            data: cubemapData.data,
            preload: cubemapData.preload,
            onProgress: (progress) => {
                //console.log('createSprite: ' + cubemapData.name + ', progress: ' + progress);
            },
        };
        let missing = false;
        let textures = [];
        for (let texture of opt.data.textures) {
            if (texture) {
                if (assetFileDic[texture]) {
                    //console.log('createCubemap missing: ' + texture + ' to: ' + assetFileDic[texture]);
                    textures.push(assetFileDic[texture]);
                } else {
                    //console.log('createCubemap missing: ' + texture);
                    missing = true;
                }
            }
        }
        if (missing) {
            log += 'missing texture';
        }
        let tem = await editor.assets.createCubemap(opt);
        tem.set('data.textures', textures);

        assetFileDic[cubemapData.id] = tem.get('id');
        return [tem, log];
    }

    async function createAssets(assetDic) {
        let startTime = new Date();
        console.log('createAssets assetDic.length: ' + Object.keys(assetDic).length);
        createLabelLog('Asset log');

        let matFolder = editor.assets.findOne(asset => asset.get('name') === 'Materials' && asset.get('type') === 'folder'
            && asset.get('path')[0] == sceneFolderPathID);
        let tmpFolder = editor.assets.findOne(asset => asset.get('name') === 'Templates' && asset.get('type') === 'folder'
            && asset.get('path')[0] == sceneFolderPathID);
        let animFolder = editor.assets.findOne(asset => asset.get('name') === 'AnimStateGraph' && asset.get('type') === 'folder'
            && asset.get('path')[0] == sceneFolderPathID);
        let spriteFolder = editor.assets.findOne(asset => asset.get('name') === 'Sprite' && asset.get('type') === 'folder'
            && asset.get('path')[0] == sceneFolderPathID);
        let can = [];
        if (matFolder) {
            can.push(matFolder);
        }
        if (tmpFolder) {
            can.push(tmpFolder);
        }
        if (animFolder) {
            can.push(animFolder);
        }
        if (spriteFolder) {
            can.push(spriteFolder);
        }
        if (can.length > 0) {
            await editor.assets.delete(can);
        }
        let tasks = [];
        tasks.push(new Promise(async resolve => {
            matFolder = await createFolder('Materials', editor.assets.get(sceneFolderPathID));
            materialFolderPathID = matFolder.get('id');
            resolve();
        }));
        tasks.push(new Promise(async resolve => {
            tmpFolder = await createFolder('Templates', editor.assets.get(sceneFolderPathID));
            templateFolderPathID = tmpFolder.get('id');
            resolve();
        }));
        tasks.push(new Promise(async resolve => {
            animFolder = await createFolder('AnimStateGraph', editor.assets.get(sceneFolderPathID));
            animStateGraphFolderPathID = animFolder.get('id');
            resolve();
        }));
        tasks.push(new Promise(async resolve => {
            spriteFolder = await createFolder('Sprite', editor.assets.get(sceneFolderPathID));
            spriteFolderPathID = spriteFolder.get('id');
            resolve();
        }));
        await Promise.all(tasks);

        //* create asset id map
        for (let [id, assetData] of Object.entries(assetDic)) {
            //if(assetData.name !== 'Wall_Prefab' && assetData.type == 'texture' && assetData.type == 'material'){
            //continue;
            //}
            //console.log('asset id: ' + id + ', name: ' + assetData.name + ', type: ' + assetData.type);
            let assetFile;
            switch (assetData.type) {
                case 'texture':
                    // playcanvas auto create file from source and use instead
                    assetData.name = assetData.name.replace('.tif', '.jpeg'); // to jpeg
                    assetData.name = assetData.name.replace('.tga', '.jpeg'); // to jpeg
                    assetFile = editor.assets.findOne(asset => asset.get('name') === assetData.name && asset.get('type') === 'texture'
                        && asset.get('path')[0] == sceneFolderPathID);
                    if (assetFile) {
                        break;
                    }
                    assetData.name = assetData.name.replace('.jpeg', '.png'); // or to png
                    assetFile = editor.assets.findOne(asset => asset.get('name') === assetData.name && asset.get('type') === 'texture'
                        && asset.get('path')[0] == sceneFolderPathID);
                    break;
                case 'render':
                    //console.log('asset id: ' + id + ', name: ' + assetData.name + ', containerAsset: ' + assetData.data.containerAsset);
                    if (assetDic[assetData.data.containerAsset]) {
                        // find glb folder
                        //console.log('asset name: ' + assetDic[assetData.data.containerAsset].name);
                        let assetFolder = editor.assets.findOne(asset => asset.get('name') === assetDic[assetData.data.containerAsset].name && asset.get('type') === 'folder'
                            && asset.get('path')[0] == sceneFolderPathID);
                        if (assetFolder) {
                            assetFile = editor.assets.findOne(asset => asset.get('data.renderIndex') === assetData.data.renderIndex && asset.get('type') === 'render'
                                && asset.get('path')[1] == assetFolder.get('id'));
                        }
                    }
                    break;
                case 'animation':
                    assetFile = editor.assets.findOne(asset => asset.get('name') === assetData.name && asset.get('type') === 'animation'
                        && asset.get('path')[0] == sceneFolderPathID);
                    break;
                case 'audio':
                    assetFile = editor.assets.findOne(asset => asset.get('name') === assetData.name && asset.get('type') === 'audio'
                        && asset.get('path')[0] == sceneFolderPathID);
                    break;
                case 'font':
                    assetFile = editor.assets.findOne(asset => asset.get('name') === assetData.name && asset.get('type') === 'font'
                        && asset.get('path')[0] == sceneFolderPathID);
                    break;
                case 'script':
                    if (assetData.name === 'ammo.js' && !editor.call("project:module:hasModule", "ammo")) {
                        editor.call("project:module:addModule", "ammo.js", "ammo");
                    }
                    break;
                default:
                    break;
            }
            //*
            if (assetFile) {
                /*
                if(assetFile.get('type') === 'font'){
                    console.log('assetFile name: ' + assetFile.get('name') + ', id: ' + assetFile.get('id'));
                }//*/
                assetFileDic[assetData.id] = assetFile.get('id');
            }//*/

            setProgressUI(true, Math.round((Object.keys(assetFileDic).length / Object.keys(assetDic).length) * 100));
        }//*/
        //* create asset file
        for (let [id, assetData] of Object.entries(assetDic)) {
            //if(assetData.name !== 'GridWhite_01_Mat'){
            //continue;
            //}
            //console.log('asset id: ' + id + ', name: ' + assetData.name + ', type: ' + assetData.type);
            let log = '';
            let asset;
            switch (assetData.type) {
                case 'material':
                    [asset, log] = await createMaterial(assetData, matFolder);
                    break;
                case 'animstategraph':
                    await createAnimStateGraph(assetData, animFolder);
                    break;
                case 'textureatlas':
                    await createTextureAtlas(assetData, spriteFolder);
                    break;
                case 'cubemap':
                    [asset, log] = await createCubemap(assetData, spriteFolder);
                    break;
                default:
                    break;
            }
            if (log !== '') {
                createEntityLog(asset, log.replace(', ', ''));
            }
            setProgressUI(true, Math.round((Object.keys(assetFileDic).length / Object.keys(assetDic).length) * 100));
        }//*/
        //* create sprite asset file
        for (let [id, assetData] of Object.entries(assetDic)) {
            //if(assetData.name !== 'GridWhite_01_Mat'){
            //continue;
            //}
            //console.log('asset id: ' + id + ', name: ' + assetData.name + ', type: ' + assetData.type);
            let log = '';
            let asset;
            switch (assetData.type) {
                case 'sprite':
                    await createSprite(assetData, spriteFolder);
                    break;
                default:
                    break;
            }
            if (log !== '') {
                createEntityLog(asset, log.replace(', ', ''));
            }
            setProgressUI(true, Math.round((Object.keys(assetFileDic).length / Object.keys(assetDic).length) * 100));
        }//*/
        //* create template file
        for (let [id, assetData] of Object.entries(assetDic)) {
            if (assetData.type == 'template') {
                await createEntity(assetData.data, '0', true);
                ReplaceResourceID(assetData.data);
                if (entityDic['0']) {
                    let assetFile = await createTemplates(assetData.name, entityDic['0'], editor.assets.get(templateFolderPathID));
                    await clearCreatedEntity();
                    if (assetFile) {
                        //console.log('assetFile id: ' + assetFile.get('id') + ', data: ' + assetFile.get('data'));
                        //console.log(assetFile.get('data'));
                        assetFileDic[assetData.id] = assetFile.get('id');
                    }
                }
            }
            setProgressUI(true, Math.round((Object.keys(assetFileDic).length / Object.keys(assetDic).length) * 100));
        }//*/
        let timeSpan = (new Date() - startTime) / 1000;
        console.log('createAssets done assetFileDic.length: ' + Object.keys(assetFileDic).length + ', timeSpan(sec): ' + timeSpan);
    }

    async function createFolder(name, folder) {
        return editor.assets.createFolder({ name: name, folder: folder });
    }

    async function setComponents(entity, data) {
        let entityLog = '';
        componentsLight(data.components.light, entity);
        componentsCamera(data.components.camera, entity);
        entityLog += await componentsRender(data.components.render, entity);
        entityLog += componentsAnim(data.components.anim, entity);
        componentsAudioListener(data.components.audioListener, entity);
        entityLog += componentsSound(data.components.sound, entity);
        entityLog += componentsSprite(data.components.sprite, entity);
        componentsScreen(data.components.screen, entity);
        entityLog += componentsElement(data.components.element, entity);
        componentsButton(data.components.button, entity);
        componentsCollision(data.components.collision, entity);
        componentsRigidbody(data.components.rigidbody, entity);
        entityLog += componentsParticlesystem(data.components.particlesystem, entity);
        componentsLayoutgroup(data.components.layoutgroup, entity);
        componentsLayoutchild(data.components.layoutchild, entity);
        componentsScrollview(data.components.scrollview, entity);
        componentsScrollbar(data.components.scrollbar, entity);
        return entityLog;
    }

    async function setEntityData(entity, data, mutiScale = false) {
        //console.log('setEntityData mutiScale: ' + mutiScale);
        entity.set('name', data.name);
        entity.set('enabled', data.enabled);
        entity.set('position', [data.position[0], data.position[1], data.position[2]]);
        entity.set('rotation', [data.rotation[0], data.rotation[1], data.rotation[2]]);
        if (mutiScale) {
            let scale = entity.get('scale');
            //console.log('setEntityData scale: ' + scale);
            entity.set('scale', [scale[0] * data.scale[0], scale[1] * data.scale[1], scale[2] * data.scale[2]]);
        } else {
            entity.set('scale', [data.scale[0], data.scale[1], data.scale[2]]);
        }
        return await setComponents(entity, data);
    }

    async function createEntityObject(entityData, par) {
        if (!par) {
            par = entityDic['playcanvas_root'];
        }
        //console.log('createEntityObject name: ' + entityData.name + ', par: ' + par.get('name'));
        let entityLog = '';
        let entity = editor.entities.create({
            name: entityData.name,
            parent: par,
            enabled: entityData.enabled,
            position: [entityData.position[0], entityData.position[1], entityData.position[2]],
            rotation: [entityData.rotation[0], entityData.rotation[1], entityData.rotation[2]],
            scale: [entityData.scale[0], entityData.scale[1], entityData.scale[2]],
            template_ent_ids: entityData.template_ent_ids,
            template_id: assetFileDic[entityData.template_id],
            index: par.get('children').length
        });
        return [entity, await setComponents(entity, entityData)];
    }

    async function createEntity(entityDataDic, id, isTemplate = false) {
        let entityData = entityDataDic[id];
        if (!entityData || entityDic[entityData.resource_id]) { /* prevent duplicate entity
            if(entityDic[entityData.resource_id]){
                console.log('createEntity skip id: ' + id + ', entityDic.name: ' + entityDic[entityData.resource_id].get('name'));
            }else{
                console.log('createEntity skip id: ' + id + ', null entityData');
            }//*/
            return;
        }
        //console.log('createEntity id: ' + id + ', name: ' + entityData.name + ', isTemplate: ' + isTemplate);

        try {
            // create entity
            let par = entityDic[entityData.parent];
            let parData = entityDataDic[entityData.parent];
            let entity;
            if (par && par != editor.entities.root) { // && parData.template_id
                let index = parData.children.findIndex((a) => a === id);
                //console.log('createEntity name: ' + entityData.name + ', index: ' + index);
                let cEntity = editor.entities.get(par.get('children')[index]);
                if (cEntity) { // if template include this entity  && cEntity.get('name') === entityData.name
                    entity = cEntity;
                }
            }
            let entityLog = '';
            //console.log('createEntity template_id: ' + entityData.template_id);
            if (entity) {
                entityLog += await setEntityData(entity, entityData);
            }
            else if (entityData.template_id) {
                entity = (await instantiateTemplates(assetFileDic[entityData.template_id], par))[0];
                if (entity) {
                    entityLog += await setEntityData(entity, entityData);
                } else {
                    console.log('instantiateTemplates fail: ' + entityData.name);
                    entityLog += ', missing template';
                }
            }
            if (!entity) {
                let [tmpE, tmpLog] = await createEntityObject(entityData, par);
                entity = tmpE;
                entityLog += tmpLog;
            }
            entityDic[entityData.resource_id] = entity;
            if (!isTemplate) {
                if (entityData.hasUnsupport) {
                    entityLog += ', has unsupport';
                }
                createEntityLog(entity, entityLog.replace(', ', ''));
                setProgressUI(true, Math.round((Object.keys(entityDic).length / Object.keys(entityDataDic).length) * 100));
            }
        } catch (response) {
            console.log('createEntity: ' + entityData.name + ', catch: ' + response);
            //createEntityLog(entity, entityLog.replace(', ', ''));
            setProgressUI(true, Math.round((Object.keys(entityDic).length / Object.keys(entityDataDic).length) * 100));
        }
        // create child
        for (let cId of entityData.children) {
            await sleep(10);
            await createEntity(entityDataDic, cId, isTemplate);
        }
        //console.log('createEntity: ' + entityData.name);
    }

    function ReplaceResourceID(entityData) {
        //console.log('ReplaceResourceID!');
        for (let [id, entity] of Object.entries(entityDic)) {
            let data = entityData[id];
            if (data) {
                //console.log('ReplaceResourceID: ' + data.name + ', id: ' + id);
                if (entity.get('components.render') && !entity.get('components.render.rootBone')) {
                    if (data.components.render && data.components.render.rootBone) {
                        if (entityDic[data.components.render.rootBone]) {
                            entity.set('components.render.rootBone', entityDic[data.components.render.rootBone].get('resource_id'));
                        }
                    }
                }

                if (entity.get('components.button') && !entity.get('components.button.imageEntity')) {
                    if (data.components.button && data.components.button.imageEntity) {
                        if (entityDic[data.components.button.imageEntity]) {
                            entity.set('components.button.imageEntity', entityDic[data.components.button.imageEntity].get('resource_id'));
                        }
                    }
                }

                if (entity.get('components.scrollview')) {
                    if (!entity.get('components.scrollview.viewportEntity') && data.components.scrollview && data.components.scrollview.viewportEntity) {
                        if (entityDic[data.components.scrollview.viewportEntity]) {
                            entity.set('components.scrollview.viewportEntity', entityDic[data.components.scrollview.viewportEntity].get('resource_id'));
                        }
                    }
                    if (!entity.get('components.scrollview.contentEntity') && data.components.scrollview && data.components.scrollview.contentEntity) {
                        if (entityDic[data.components.scrollview.contentEntity]) {
                            entity.set('components.scrollview.contentEntity', entityDic[data.components.scrollview.contentEntity].get('resource_id'));
                        }
                    }
                    if (!entity.get('components.scrollview.horizontalScrollbarEntity') && data.components.scrollview && data.components.scrollview.horizontalScrollbarEntity) {
                        if (entityDic[data.components.scrollview.horizontalScrollbarEntity]) {
                            entity.set('components.scrollview.horizontalScrollbarEntity', entityDic[data.components.scrollview.horizontalScrollbarEntity].get('resource_id'));
                        }
                    }
                    if (!entity.get('components.scrollview.verticalScrollbarEntity') && data.components.scrollview && data.components.scrollview.verticalScrollbarEntity) {
                        if (entityDic[data.components.scrollview.verticalScrollbarEntity]) {
                            entity.set('components.scrollview.verticalScrollbarEntity', entityDic[data.components.scrollview.verticalScrollbarEntity].get('resource_id'));
                        }
                    }
                }

                if (entity.get('components.scrollbar') && !entity.get('components.scrollbar.handleEntity')) {
                    if (data.components.scrollbar && data.components.scrollbar.handleEntity) {
                        if (entityDic[data.components.scrollbar.handleEntity]) {
                            entity.set('components.scrollbar.handleEntity', entityDic[data.components.scrollbar.handleEntity].get('resource_id'));
                        }
                    }
                }
            }
        }
    }

    async function textureToCubemap(texture, nameSplit, cubeName) {
        editor.call("assets:textureToCubemap", texture);
        let cubeMap;
        for (let i = 0; i < 100; i++) {
            await sleep(1000);
            cubeMap = editor.assets.findOne(asset => asset.get('name') === cubeName && asset.get('type') === 'cubemap'
                && asset.get('path')[0] == sceneFolderPathID);
            if (cubeMap) {
                console.log('textureToCubemap await:' + i);
                let tmpMap = editor.assets.findOne(asset => asset.get('name') === nameSplit[0] + '_nx.png' && asset.get('type') === 'texture'
                    && asset.get('path')[0] == sceneFolderPathID);
                assetCan.push(tmpMap.get('id'));

                tmpMap = editor.assets.findOne(asset => asset.get('name') === nameSplit[0] + '_ny.png' && asset.get('type') === 'texture'
                    && asset.get('path')[0] == sceneFolderPathID);
                assetCan.push(tmpMap.get('id'));

                tmpMap = editor.assets.findOne(asset => asset.get('name') === nameSplit[0] + '_nz.png' && asset.get('type') === 'texture'
                    && asset.get('path')[0] == sceneFolderPathID);
                assetCan.push(tmpMap.get('id'));

                tmpMap = editor.assets.findOne(asset => asset.get('name') === nameSplit[0] + '_px.png' && asset.get('type') === 'texture'
                    && asset.get('path')[0] == sceneFolderPathID);
                assetCan.push(tmpMap.get('id'));

                tmpMap = editor.assets.findOne(asset => asset.get('name') === nameSplit[0] + '_py.png' && asset.get('type') === 'texture'
                    && asset.get('path')[0] == sceneFolderPathID);
                assetCan.push(tmpMap.get('id'));

                tmpMap = editor.assets.findOne(asset => asset.get('name') === nameSplit[0] + '_pz.png' && asset.get('type') === 'texture'
                    && asset.get('path')[0] == sceneFolderPathID);
                assetCan.push(tmpMap.get('id'));

                assetCan.push(cubeMap.get('id'));
                break;
            }
        }
        return cubeMap;
    }
    async function setSceneSettings(setting) {
        console.log('setSceneSettings');
        editor.settings.scene.set('physics', setting.physics);
        if (setting.render.skybox) {
            if (assetFileDic[setting.render.skybox]) {
                let texture = editor.assets.get(assetFileDic[setting.render.skybox]);
                let cubeMap;
                if (texture) {
                    if (texture.get('type') === 'texture') {
                        let nameSplit = texture.get('name').split('.');
                        let cubeName = nameSplit[0] + '_cubemap';
                        //console.log('textureToCubemap cubeName:' + cubeName);
                        cubeMap = editor.assets.findOne(asset => asset.get('name') === cubeName && asset.get('type') === 'cubemap'
                            && asset.get('path')[0] == sceneFolderPathID);
                        if (!cubeMap) {
                            cubeMap = await textureToCubemap(texture, nameSplit, cubeName);
                        }
                    } else if (texture.get('type') === 'cubemap') {
                        cubeMap = texture;
                    }
                }

                if (cubeMap) {
                    setting.render.skybox = cubeMap.get('id');
                } else {
                    console.log('textureToCubemap missing cubemap');
                    setting.render.skybox = null;
                }
            } else {
                console.log('textureToCubemap missing cubemap');
                setting.render.skybox = null;
            }
        }
        editor.settings.scene.set('render', setting.render);
    }

    function setApplicationProperties(apData) {
        console.log('setApplicationProperties');
        let projectSettings = editor.call('settings:project');
        projectSettings.set('layers', apData.layers);
        // remove old custom layer order
        for (let i = projectSettings.get('layerOrder').length - 1; i >= 0; i--) {
            if (projectSettings.get('layerOrder')[i].layer > 999) {
                //console.log(projectSettings.get('layerOrder')[i].layer);
                projectSettings.remove('layerOrder', i);
            }
        }
        // insert old custom layer order
        for (let i = 0; i < apData.layerOrder.length; i++) {
            if (apData.layerOrder[i].layer > 999) {
                //console.log(apData.layerOrder[i].layer);
                projectSettings.insert('layerOrder', apData.layerOrder[i], i);
            }
        }
        // rendering setting
        projectSettings.set('width', apData.width);
        projectSettings.set('height', apData.height);
        projectSettings.set('resolutionMode', apData.resolutionMode);
        projectSettings.set('fillMode', apData.fillMode);
        projectSettings.set('antiAlias', apData.antiAlias);
    }

    async function runProgress() {
        if (isCreatingScene) {
            console.log('runProgress is Creating');
            return;
        }
        let startTime = new Date();
        isCreatingScene = true;
        clearData();
        setProgressUI(true);

        const configAsset = editor.assets.findOne(asset => asset.get('name') === 'config.json' && asset.get('path').length === 1);
        if (!configAsset) {
            console.log('runProgress config.json not found');
            createLabelLog('runProgress config.json not found', true);

            setProgressUI();
            isCreatingScene = false;
            return;
        }
        let url = configAsset.json().file.url;
        //console.log('url: ' + url);
        const configJson = await api(url);
        let sceneName = 'scene.json';
        if (configJson.scenes) {
            sceneName = configJson.scenes[0].url;
            console.log('runProgress configJson.scenes: ' + configJson.scenes[0].url + ', assets: ' + Object.keys(configJson.assets).length);
        }

        const sceneAsset = editor.assets.findOne(asset => asset.get('name') == sceneName && asset.get('path')[0] === configAsset.get('path')[0]);
        if (!sceneAsset) {
            console.log('runProgress scene.json not found');
            createLabelLog('runProgress scene.json not found', true);

            setProgressUI();
            isCreatingScene = false;
            return;
        }
        let path = sceneAsset.json().path;
        sceneFolderPathID = path;
        url = sceneAsset.json().file.url;
        //console.log('url: ' + url);
        const sceneJson = await api(url);
        if (sceneJson.version) {
            console.log('runProgress sceneJson.version: ' + sceneJson.version);
        }
        try {
            await createAssets(configJson.assets).catch(response => {
                console.log(response);
            });
            await setSceneSettings(sceneJson.settings); // todo improve -> none sync to reduce time cost
            setApplicationProperties(configJson.application_properties);

            createDivider();
            createLabelLog('Entity List');
            console.log('runProgress start entities.length: ' + Object.keys(sceneJson.entities).length);
            for (let [id, entity] of Object.entries(sceneJson.entities)) {
                //console.log('entities: ' + id);
                await sleep(10);
                //* full work
                await createEntity(sceneJson.entities, id).catch(response => {
                    console.log(response);
                });
                /* test
                if(entity.name === 'screaming_reaper'){
                    await createEntity(sceneJson.entities, id);
                } //*/
            }
            ReplaceResourceID(sceneJson.entities);
            let timeSpan = (new Date() - startTime) / 1000;
            console.log('runProgress done entities.length: ' + Object.keys(entityDic).length + ', timespan(sec): ' + timeSpan);
            //console.log('runProgress done entities: ' + Object.values(entityDic));
            //const entities = editor.entities.list();
            //console.log('runProgress done entities.length: ' + entities.length);
            //*
        } catch (e) {
            let timeSpan = (new Date() - startTime) / 1000;
            console.error('runProgress error: ' + e + ', timespan(sec): ' + timeSpan);
            createLabelLog('runProgress error: ' + e, true);
        }//*/
        setProgressUI();
        isCreatingScene = false;
    }

    async function clearCreatedEntity(showLog = false) {
        let entityList = [];
        if (entityDic) {
            for (let [id, entity] of Object.entries(entityDic)) {
                //console.log('clearCreated id: ' + id + ', sceneRootName: ' + sceneRootName);
                if (entity && entity != editor.entities.root) { // Cannot delete root entity 'root'
                    entityList.push(entity);
                }
            }
        }
        if (showLog) {
            console.log('clearCreatedEntity: ' + entityList.length);
        }
        if (entityList.length > 0) {
            try {
                await editor.entities.delete(entityList);
            } catch (e) {
                console.error('clearCreatedEntity error: ' + e);
                createLabelLog('clearCreatedEntity error: ' + e, true);
            }//*/
        }
        entityDic = { 'playcanvas_root': editor.entities.root };
    }

    async function clearScene() {
        let entityList = [];
    }

    async function clearCreated() {
        // todo add remove layers?
        await clearCreatedEntity(true);
        setProgressUI(true, 50);
        let can = [];
        for (let id of assetCan) {
            let tmp = editor.assets.get(id);
            if (tmp) {
                can.push(tmp);
            }
        }
        if (editor.assets.get(materialFolderPathID)) {
            can.push(editor.assets.get(materialFolderPathID));
        }
        if (editor.assets.get(templateFolderPathID)) {
            can.push(editor.assets.get(templateFolderPathID));
        }
        if (editor.assets.get(animStateGraphFolderPathID)) {
            can.push(editor.assets.get(animStateGraphFolderPathID));
        }
        if (editor.assets.get(spriteFolderPathID)) {
            can.push(editor.assets.get(spriteFolderPathID));
        }
        if (can.length > 0) {
            await editor.assets.delete(can);
        }
        setProgressUI();
        console.log('done clearCreated');
    }

    function clearData() {
        materialList = {};
        assetFileDic = {};
        entityDic = { 'playcanvas_root': editor.entities.root }; // 'root'
        assetCan = [];
    }
    // main code start
    //console.log('on script run');
    // global var
    var sceneFolderPathID;
    var materialFolderPathID;
    var templateFolderPathID;
    var animStateGraphFolderPathID;
    var spriteFolderPathID;
    var entityDic; // created entities [id, entity]
    var materialList; // prevent modify same matetial
    var assetFileDic; // record asset id pair
    var assetCan; // asset list need remove
    var isCreatingScene;
    // UI
    var mainPanelUI;
    var progressUI = null;
    var debugSelection = false;
    // Wait until the Editor is available before adding the button
    editor.once('assets:load', async () => {
        //console.log('on assets load');
        initMainPanel();
    });
    //* debug select
    editor.selection.on('change', (items) => {
        if (debugSelection) {
            console.log(items);
        }
    }); //*/
})();
//